'use strict';

const Controller = require('egg').Controller;

class OtherController extends Controller {
  async index() {
    const { ctx } = this;
    ctx.body = 'hi, OtherController';
  }

  /**
     * 1.采集员认证统计(计算精准-已测试)
     */
  async selectUserByAuth() {
    const { ctx, service } = this;
    const query = ctx.request.body;
    delete query.deptId;
    if (Object.keys(query).length === 0) {
      query.dept1 = this.app.config.dept1ObjectId;
    }
    const result = await service.other.selectUserByAuth(query);
    ctx.body = result;
  }

  /**
     * 2.运营分析(计算精准-已测试)
     */
  async fourquan() {
    const { ctx, service } = this;
    const query = ctx.request.body;
    delete query.deptId;
    if (Object.keys(query).length === 0) {
      query.dept1 = this.app.config.dept1ObjectId;
    }
    const result = await service.other.fourquan(query);
    ctx.body = result;
  }

  /**
     * 3.首页左下角采集(计算精准-已测试)
     */
  async infomonth() {
    const { ctx, service } = this;
    const query = ctx.request.body;
    delete query.deptId;
    if (Object.keys(query).length === 0) {
      query.dept1 = this.app.config.dept1ObjectId;
    }
    const result = await service.other.infomonth(query);
    ctx.body = result;
  }

  /**
     * 4.采集员 性别,政治面貌(计算精准-已测试)
     */
  async selectSexAndLook() {
    const { ctx, service } = this;
    const query = ctx.request.body;
    delete query.deptId;
    const result = await service.other.selectSexAndLook(query);
    ctx.body = result;
  }

  /**
     * 5.采集员认证统计(计算精准-已测试)
     */
  async selectUserByAuth() {
    const { ctx, service } = this;
    const query = ctx.request.body;
    delete query.deptId;
    const result = await service.other.selectUserByAuth(query);
    ctx.body = result;
  }

  async selectListOfSetRedisByCc() {
    const { ctx, service } = this;
    const query = {};
    const deptId = '5d53a9c8165644593240c946';
    query.dept2 = this.app.mongoose.Types.ObjectId(deptId);

    // 1.已审核老年人人数
    const ElderlyCountResult = await service.info.oldnum(query);
    const oldnum = ElderlyCountResult.oldnum;
    delete query.status;

    // 2.认证巡访员人数
    const authUserNumResult = await service.other.selectUserByAuth(query);
    const authUserNum = authUserNumResult[0].count;
    delete query.role;

    // 3.老年人关爱服务统计
    const oldDemand = await service.info.oldDemand(query);
    delete query.status;

    // 4.老年人巡访意愿频次统计
    const visitFrequency = await service.info.visitFrequency(query);
    delete query.status;

    // 5.老年人类别统计
    delete query.dept2;
    query.level = '2';
    query.deptLevel = 3;
    query.deptFid = deptId;
    const oldTypeDept3 = await service.other.oldType(query);

    const resultArr = [];
    resultArr.push({ label: '老年人信息(人)', field: 'oldnum', value: oldnum });
    resultArr.push({ label: '认证巡防员(人)', field: 'authUserNum', value: authUserNum });
    resultArr.push({ label: '老年人关爱服务统计', field: 'oldDemand', value: oldDemand });
    resultArr.push({ label: '老年人巡访意愿频次统计', field: 'visitFrequency', value: visitFrequency });
    resultArr.push({ label: '老年人类别统计', field: 'oldTypeDept3', value: oldTypeDept3 });

    ctx.body = resultArr;
  }

  async selectListByCc() {
    const StatisticsListOfCc = await this.app.redis.get('StatisticsListOfCc');
    const result = JSON.parse(StatisticsListOfCc);
    if (result.status === 200) {
      delete result.res;
      delete result.headers;
    } else {
      this.ctx.error('获取数据错误，请联系管理员');
    }
    this.ctx.body = result;
  }


}
module.exports = OtherController;
