'use strict';
const Subscription = require('egg').Subscription;
class AccessToken extends Subscription {
  static get schedule() {
    return {
      // cron: '0 0 2 * * *',
      cron: '0 30 15 * * *',
      // interval: '7100s', // 7200-100 秒间隔  接近2个小时执行一次
      type: 'all', // 指定所有的 worker 都需要执行
    };
  }
  // subscribe 是真正定时任务执行时被运行的函数
  async subscribe() {
    // this.service.dataToGBService.dataToGB();

    // const url = 'https://info.windd.cn/bigScreen/chart/other/selectListOfSetRedisByCc'; // 正式
    const url = 'http://localhost:8093/bigScreen/chart/other/selectListOfSetRedisByCc'; // 本地测试
    const res = await this.ctx.curl(url, {
      method: 'POST',
      contentType: 'json',
      dataType: 'json',
      timeout: 30000, // 设置超时时间为30秒
    });

    this.app.redis.set('StatisticsListOfCc', JSON.stringify(res),
      'EX', 7100);
  }

}
module.exports = AccessToken;
